import numpy as np
import open3d as o3d
import os
import sys
import trimesh

"""
1. Load all point clouds and merge them together:
-Assume correct calibration of extrinsic parameters of the cameras
-Process the point cloud---downsample and remove outliers
-You can do it on the final merged point cloud, or on each individual point cloud
-Open3D Point Cloud Documentation: http://www.open3d.org/docs/release/python_api/open3d.geometry.PointCloud.hthml
-Open3D Point Cloud Tutorial: http://www.open3d.org/docs/latest/tutorial/Basic/pointcloud.html
"""

#TODO: Load, concatenate and visualise final point cloud

"""
2. Create a bounding box crop the workspace:
-We have set minimum and maximum values of X and Y for you. set Z-values to focus on the object.
-GraspIt! requires no floor, while GPD does, so you should have two different sets of min/max values.
-Then use the crop() method from open3d
"""

MIN_X, MAX_X,  MIN_Y, MAX_Y, MIN_Z, MAX_Z  = 0.1, 0.9, 0.2, 1, np.nan, np.nan


box = [[MIN_X, MIN_Y, MIN_Z], [MAX_X, MIN_Y, MIN_Z], [MAX_X, MAX_Y, MIN_Z], [MIN_X, MAX_Y, MIN_Z],
       [MIN_X, MIN_Y, MAX_Z], [MAX_X, MIN_Y, MAX_Z], [MAX_X, MAX_Y, MAX_Z], [MIN_X, MAX_Y, MAX_Z]]
bbox = o3d.geometry.OrientedBoundingBox().create_from_points(o3d.utility.Vector3dVector(box))

#TODO: crop the point cloud using the bounding box.

"""
Next, we save the point cloud for use with GPD
"""
#Formatting to uniformly color the object and translate it to the origin. Replace the variable name 'pcl' with your point cloud variable.
pcl=pcl.paint_uniform_color([1,0,0])
pcl=pcl.translate([0,0,0],False)

#TODO: Save the point cloud to file. Flie extension should be .pcd

"""
Unlike GPD which can work directly with point clouds, GraspIt! requires a mesh model for objects. Next we will convert the point cloud to mesh.
-You can get inspired here http://www.open3d.org/docs/latest/tutorial/Advanced/surface_reconstruction.html
-Open3D documentation is here: http://www.open3d.org/docs/release/python_api/open3d.geometry.TriangleMesh.html

Further, (optionally, if you are unsatisfied by how your object mesh looks) you may try to fix and refine your mesh using the following functions:
mesh.orient_triangles()
mesh.remove_degenerate_triangles()
mesh.remove_duplicated_vertices()
mesh.remove_duplicated_triangles()
mesh.remove_non_manifold_edges()
"""

#TODO: Create a mesh from the point cloud and translate it to the origin.
#TODO: Save the mesh to file. File extension should be .ply